<?php

namespace App\Filament\Exports;

use App\Models\RejectReason;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class RejectReasonExporter extends Exporter
{
    protected static ?string $model = RejectReason::class;

    public static function getColumns(): array
    {
         static $rowNumber = 0;
        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant.name')
            ->label('PLANT'),
            ExportColumn::make('line.name')
            ->label('LINE'),
            ExportColumn::make('workGroupMaster.name')
             ->label('WORK GROUP NAME'),
            ExportColumn::make('code')
             ->label('CODE'),
            ExportColumn::make('reason')
             ->label('REASON'),
            ExportColumn::make('created_by')
             ->label('CREATED BY'),
            ExportColumn::make('created_at')
             ->label('CREATED AT'),
            ExportColumn::make('updated_at')
             ->label('UPDATED AT'),
            ExportColumn::make('deleted_at')
             ->label('DELETED AT')
             ->enabledByDefault(false),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your reject reason export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
